--luacheck: ignore
local value = 4
local rounds_survived = 1

local this = {}

function add_unit(health_multiplier)
    local health = math.floor(75 * health_multiplier)
    local xp_modifier = math.round(1 / health_multiplier, 5)
    local a = {
        health,
        xp_modifier,
        { max_health = health }
    }

    log(serpent.line(a))
end

this.modified_unit_health = {
    current_value = 1.2,
    limit_value = 150,
    health_increase_per_boss_wave = 0.5 -- wave % 25 == 0 at wave 2k boost is at 41.2
}

this.modified_boss_unit_health = {
    current_value = 2,
    limit_value = 500,
    health_increase_per_boss_wave = 4 -- wave % 25 == 0 at wave 2k boost is at 322
}

this.unit_settings = {
    scale_units_by_health = {
        ['small-biter'] = 1,
        ['medium-biter'] = 0.75,
        ['big-biter'] = 0.5,
        ['behemoth-biter'] = 0.25,
        ['small-spitter'] = 1,
        ['medium-spitter'] = 0.75,
        ['big-spitter'] = 0.5,
        ['behemoth-spitter'] = 0.25
    }
}

local modified_unit_health = this.modified_unit_health

local function scale(setting, limit, factor)
    factor = factor or 1.05
    -- Use a linear scaling instead of exponential
    local scale_value = math.floor(setting + (factor * rounds_survived))
    if limit and scale_value >= limit then
        return limit
    end
    return math.floor(scale_value)
end

for _ = 1, 99 do
    rounds_survived = rounds_survived + 1
    local v = scale(value, 155, 0.319) -- Note: 'factor' here represents a per-round increment
    modified_unit_health.current_value = v
    local final_health = math.round(modified_unit_health.current_value * this.unit_settings.scale_units_by_health['medium-biter'], 3)

    -- log(serpent.block(final_health))
    print('round: ' .. rounds_survived .. ' final health: ' .. final_health)
    add_unit(final_health)
end
